---
title: WP Main Services
author:
date: 2024-12-05
...

# WP Main Services {#wp-main-services}

## plugins.wp.goal (`DATA`) {#goal}

Proof Obligations


> [`goal`](#goal)  `::=` `$wpo`
  

## plugins.wp.prover (`DATA`) {#prover}

Prover Identifier


> [`prover`](#prover)  `::=` `$prover`
  

## plugins.wp.provers (`STATE`) {#provers}

Selected Provers


## plugins.wp.signalProvers (`SIGNAL`) {#signalprovers}

Signal for state [`provers`](#provers) 


## plugins.wp.getProvers (`GET`) {#getprovers}

Getter for state [`provers`](#provers) 


> _input_ `::=` _null_
  

> _output_ `::=` [`prover`](index.md#prover)  `[]`
  

## plugins.wp.setProvers (`SET`) {#setprovers}

Setter for state [`provers`](#provers) 


> _input_ `::=` [`prover`](index.md#prover)  `[]`
  

> _output_ `::=` _null_
  

## plugins.wp.process (`STATE`) {#process}

Server Processes


## plugins.wp.signalProcess (`SIGNAL`) {#signalprocess}

Signal for state [`process`](#process) 


## plugins.wp.getProcess (`GET`) {#getprocess}

Getter for state [`process`](#process) 


> _input_ `::=` _null_
  

> _output_ `::=` _number_
  

## plugins.wp.setProcess (`SET`) {#setprocess}

Setter for state [`process`](#process) 


> _input_ `::=` _number_
  

> _output_ `::=` _null_
  

## plugins.wp.timeout (`STATE`) {#timeout}

Prover's Timeout


## plugins.wp.signalTimeout (`SIGNAL`) {#signaltimeout}

Signal for state [`timeout`](#timeout) 


## plugins.wp.getTimeout (`GET`) {#gettimeout}

Getter for state [`timeout`](#timeout) 


> _input_ `::=` _null_
  

> _output_ `::=` _number_
  

## plugins.wp.setTimeout (`SET`) {#settimeout}

Setter for state [`timeout`](#timeout) 


> _input_ `::=` _number_
  

> _output_ `::=` _null_
  

## plugins.wp.ProverInfos (`ARRAY`) {#proverinfos}

Available Provers


## plugins.wp.signalProverInfos (`SIGNAL`) {#signalproverinfos}

Signal for array [`ProverInfos`](#proverinfos) 


## plugins.wp.ProverInfosData (`DATA`) {#proverinfosdata}

Data for array rows [`ProverInfos`](#proverinfos) 


> [`ProverInfosData`](#proverinfosdata)  `::= {` _fields…_ `}`
  

| Field | Format | Description |
|:------|:------:|:------------|
| `"prover"` | [`prover`](index.md#prover)  | Entry identifier. |
| `"name"` | _string_ | Prover Name |
| `"version"` | _string_ | Prover Version |
| `"descr"` | _string_ | Prover Full Name (description) |


## plugins.wp.fetchProverInfos (`GET`) {#fetchproverinfos}

Data fetcher for array [`ProverInfos`](#proverinfos) 


> _input_ `::=` _number_
  

> _output_ `::=` `{` _output…_ `}`
  

| Output | Format | Description |
|:-------|:------:|:------------|
| `"reload"` | _boolean_ | array fully reloaded |
| `"removed"` | [`prover`](index.md#prover)  `[]` | removed entries |
| `"updated"` | [`ProverInfosData`](index.md#proverinfosdata)  `[]` | updated entries |
| `"pending"` | _number_ | remaining entries to be fetched |


## plugins.wp.reloadProverInfos (`GET`) {#reloadproverinfos}

Force full reload for array [`ProverInfos`](#proverinfos) 


> _input_ `::=` _null_
  

> _output_ `::=` _null_
  

## plugins.wp.result (`DATA`) {#result}

Prover Result


> [`result`](#result)  `::=` `{` `"descr"` `:` _string_ , `"cached"` `:`
  _boolean_ , `"verdict"` `:` _string_ , `"solverTime"` `:` _number_ ,
  `"proverTime"` `:` _number_ , `"proverSteps"` `:` _number_ `}`
  

## plugins.wp.status (`DATA`) {#status}

Test Status


> [`status`](#status)  `::=` `$NORESULT` | `$COMPUTING` | `$FAILED` |
  `$STEPOUT` | `$UNKNOWN` | `$VALID` | `$PASSED` | `$DOOMED`
  

## plugins.wp.stats (`DATA`) {#stats}

Prover Result


> [`stats`](#stats)  `::=` `{` `"summary"` `:` _string_ , `"tactics"` `:`
  _number_ , `"proved"` `:` _number_ , `"total"` `:` _number_ `}`
  

## plugins.wp.goals (`ARRAY`) {#goals}

Generated Goals


## plugins.wp.signalGoals (`SIGNAL`) {#signalgoals}

Signal for array [`goals`](#goals) 


## plugins.wp.goalsData (`DATA`) {#goalsdata}

Data for array rows [`goals`](#goals) 


> [`goalsData`](#goalsdata)  `::= {` _fields…_ `}`
  

| Field | Format | Description |
|:------|:------:|:------------|
| `"wpo"` | [`goal`](index.md#goal)  | Entry identifier. |
| `"marker"` | [`marker`](../../kernel/ast.md#marker)  | Associated Marker |
| `"scope"` (opt.) | [`decl`](../../kernel/ast.md#decl)  | Associated declaration, if any |
| `"property"` | [`marker`](../../kernel/ast.md#marker)  | Property Marker |
| `"fct"` (opt.) | _string_ | Associated function name, if any |
| `"bhv"` (opt.) | _string_ | Associated behavior name, if any |
| `"thy"` (opt.) | _string_ | Associated axiomatic name, if any |
| `"name"` | _string_ | Informal Property Name |
| `"smoke"` | _boolean_ | Smoking (or not) goal |
| `"passed"` | _boolean_ | Valid or Passed goal |
| `"status"` | [`status`](index.md#status)  | Verdict, Status |
| `"stats"` | [`stats`](index.md#stats)  | Prover Stats Summary |
| `"proof"` | _boolean_ | Proof Tree |
| `"script"` (opt.) | _string_ | Script File |
| `"saved"` | _boolean_ | Saved Script |


## plugins.wp.fetchGoals (`GET`) {#fetchgoals}

Data fetcher for array [`goals`](#goals) 


> _input_ `::=` _number_
  

> _output_ `::=` `{` _output…_ `}`
  

| Output | Format | Description |
|:-------|:------:|:------------|
| `"reload"` | _boolean_ | array fully reloaded |
| `"removed"` | [`goal`](index.md#goal)  `[]` | removed entries |
| `"updated"` | [`goalsData`](index.md#goalsdata)  `[]` | updated entries |
| `"pending"` | _number_ | remaining entries to be fetched |


## plugins.wp.reloadGoals (`GET`) {#reloadgoals}

Force full reload for array [`goals`](#goals) 


> _input_ `::=` _null_
  

> _output_ `::=` _null_
  

## plugins.wp.generateRTEGuards (`EXEC`) {#generaterteguards}

Generate RTE guards for the function


> _input_ `::=` [`marker`](../../kernel/ast.md#marker) 
  

> _output_ `::=` _null_
  

## plugins.wp.startProofs (`EXEC`) {#startproofs}

Generate goals and run provers


> _input_ `::=` [`marker`](../../kernel/ast.md#marker) 
  

> _output_ `::=` _null_
  

## plugins.wp.serverActivity (`SIGNAL`) {#serveractivity}

Proof Server Activity


## plugins.wp.getScheduledTasks (`GET`) {#getscheduledtasks}

Scheduled tasks in proof server


> _input_ `::=` _null_
  

> _output_ `::=` `{` _output…_ `}`
  

| Output | Format | Description |
|:-------|:------:|:------------|
| `"procs"` | _number_ | Max parallel tasks |
| `"active"` | _number_ | Active tasks |
| `"done"` | _number_ | Finished tasks |
| `"todo"` | _number_ | Remaining jobs |


> _signals_
  

* `plugins.wp.serverActivity`


## plugins.wp.cancelProofTasks (`SET`) {#cancelprooftasks}

Cancel all scheduled proof tasks


> _input_ `::=` _null_
  

> _output_ `::=` _null_
  